/**
 * <copyright> </copyright>
 * 
 * $Id: DocumentRoot.java,v 1.1 2006-03-31 21:58:54 melder Exp $
 */
package org.eclipse.stp.core.tests.properties;

import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.FeatureMap;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.stp.core.tests.props.DocumentRoot#getMixed <em>Mixed</em>}</li>
 * <li>{@link org.eclipse.stp.core.tests.props.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}</li>
 * <li>{@link org.eclipse.stp.core.tests.props.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}</li>
 * <li>{@link org.eclipse.stp.core.tests.props.DocumentRoot#getImplementationProperties <em>Implementation Properties</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.stp.core.tests.props.PropsPackage#getDocumentRoot()
 * @model extendedMetaData="name='' kind='mixed'"
 * @generated
 */
public interface DocumentRoot extends EObject {
   /**
    * Returns the value of the '<em><b>Mixed</b></em>' attribute list. The
    * list contents are of type
    * {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}. <!-- begin-user-doc
    * -->
    * <p>
    * If the meaning of the '<em>Mixed</em>' attribute list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Mixed</em>' attribute list.
    * @see org.eclipse.stp.core.tests.props.PropsPackage#getDocumentRoot_Mixed()
    * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry"
    *        many="true" extendedMetaData="kind='elementWildcard' name=':mixed'"
    * @generated
    */
   FeatureMap getMixed();

   /**
    * Returns the value of the '<em><b>XMLNS Prefix Map</b></em>' map. The
    * key is of type {@link java.lang.String}, and the value is of type
    * {@link java.lang.String}, <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>XMLNS Prefix Map</em>' map isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>XMLNS Prefix Map</em>' map.
    * @see org.eclipse.stp.core.tests.props.PropsPackage#getDocumentRoot_XMLNSPrefixMap()
    * @model mapType="org.eclipse.emf.ecore.EStringToStringMapEntry"
    *        keyType="java.lang.String" valueType="java.lang.String"
    *        transient="true" extendedMetaData="kind='attribute'
    *        name='xmlns:prefix'"
    * @generated
    */
   EMap getXMLNSPrefixMap();

   /**
    * Returns the value of the '<em><b>XSI Schema Location</b></em>' map.
    * The key is of type {@link java.lang.String}, and the value is of type
    * {@link java.lang.String}, <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>XSI Schema Location</em>' map isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>XSI Schema Location</em>' map.
    * @see org.eclipse.stp.core.tests.props.PropsPackage#getDocumentRoot_XSISchemaLocation()
    * @model mapType="org.eclipse.emf.ecore.EStringToStringMapEntry"
    *        keyType="java.lang.String" valueType="java.lang.String"
    *        transient="true" extendedMetaData="kind='attribute'
    *        name='xsi:schemaLocation'"
    * @generated
    */
   EMap getXSISchemaLocation();

   /**
    * Returns the value of the '<em><b>Implementation Properties</b></em>'
    * containment reference. <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Implementation Properties</em>' containment
    * reference isn't clear, there really should be more of a description
    * here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>Implementation Properties</em>'
    *         containment reference.
    * @see #setImplementationProperties(PropertiesImplementation)
    * @see org.eclipse.stp.core.tests.props.PropsPackage#getDocumentRoot_ImplementationProperties()
    * @model containment="true" resolveProxies="false" upper="-2"
    *        transient="true" volatile="true" derived="true"
    *        extendedMetaData="kind='element' name='implementation.properties'
    *        namespace='##targetNamespace'
    *        affiliation='http://www.osoa.org/xmlns/sca/0.9#implementation'"
    * @generated
    */
   PropertiesImplementation getImplementationProperties();

   /**
    * Sets the value of the '{@link org.eclipse.stp.core.tests.props.DocumentRoot#getImplementationProperties <em>Implementation Properties</em>}'
    * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @param value
    *           the new value of the '<em>Implementation Properties</em>'
    *           containment reference.
    * @see #getImplementationProperties()
    * @generated
    */
   void setImplementationProperties(PropertiesImplementation value);

} // DocumentRoot
