/**
 * <copyright> </copyright>
 * 
 * $Id: PropsPackageImpl.java,v 1.1 2006-03-31 21:58:56 melder Exp $
 */
package org.eclipse.stp.core.tests.properties.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.xml.type.XMLTypePackage;
import org.eclipse.emf.ecore.xml.type.impl.XMLTypePackageImpl;
import org.eclipse.stp.core.sca.SCAPackage;
import org.eclipse.stp.core.sca.impl.SCAPackageImpl;
import org.eclipse.stp.core.tests.properties.DocumentRoot;
import org.eclipse.stp.core.tests.properties.PropertiesImplementation;
import org.eclipse.stp.core.tests.properties.PropsFactory;
import org.eclipse.stp.core.tests.properties.PropsPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class PropsPackageImpl extends EPackageImpl implements PropsPackage {
   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   private EClass documentRootEClass             = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   private EClass propertiesImplementationEClass = null;

   /**
    * Creates an instance of the model <b>Package</b>, registered with
    * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
    * package package URI value.
    * <p>
    * Note: the correct way to create the package is via the static factory
    * method {@link #init init()}, which also performs initialization of the
    * package, or returns the registered package, if one already exists. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @see org.eclipse.emf.ecore.EPackage.Registry
    * @see org.eclipse.stp.core.tests.props.PropsPackage#eNS_URI
    * @see #init()
    * @generated
    */
   private PropsPackageImpl() {
      super(eNS_URI, PropsFactory.eINSTANCE);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   private static boolean isInited = false;

   /**
    * Creates, registers, and initializes the <b>Package</b> for this model,
    * and for any others upon which it depends. Simple dependencies are
    * satisfied by calling this method on all dependent packages before doing
    * anything else. This method drives initialization for interdependent
    * packages directly, in parallel with this package, itself.
    * <p>
    * Of this package and its interdependencies, all packages which have not yet
    * been registered by their URI values are first created and registered. The
    * packages are then initialized in two steps: meta-model objects for all of
    * the packages are created before any are initialized, since one package's
    * meta-model objects may refer to those of another.
    * <p>
    * Invocation of this method will not affect any packages that have already
    * been initialized. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @see #eNS_URI
    * @see #createPackageContents()
    * @see #initializePackageContents()
    * @generated
    */
   public static PropsPackage init() {
      if (isInited)
         return (PropsPackage) EPackage.Registry.INSTANCE
               .getEPackage(PropsPackage.eNS_URI);

      // Obtain or create and register package
      PropsPackageImpl thePropsPackage = (PropsPackageImpl) (EPackage.Registry.INSTANCE
            .getEPackage(eNS_URI) instanceof PropsPackageImpl ? EPackage.Registry.INSTANCE
            .getEPackage(eNS_URI)
            : new PropsPackageImpl());

      isInited = true;

      // Initialize simple dependencies
      SCAPackageImpl.init();
      XMLTypePackageImpl.init();

      // Create package meta-data objects
      thePropsPackage.createPackageContents();

      // Initialize created meta-data
      thePropsPackage.initializePackageContents();

      // Mark meta-data to indicate it can't be changed
      thePropsPackage.freeze();

      return thePropsPackage;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EClass getDocumentRoot() {
      return documentRootEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EAttribute getDocumentRoot_Mixed() {
      return (EAttribute) documentRootEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EReference getDocumentRoot_XMLNSPrefixMap() {
      return (EReference) documentRootEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EReference getDocumentRoot_XSISchemaLocation() {
      return (EReference) documentRootEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EReference getDocumentRoot_ImplementationProperties() {
      return (EReference) documentRootEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EClass getPropertiesImplementation() {
      return propertiesImplementationEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EAttribute getPropertiesImplementation_Any() {
      return (EAttribute) propertiesImplementationEClass
            .getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EAttribute getPropertiesImplementation_Properties() {
      return (EAttribute) propertiesImplementationEClass
            .getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EAttribute getPropertiesImplementation_AnyAttribute() {
      return (EAttribute) propertiesImplementationEClass
            .getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public PropsFactory getPropsFactory() {
      return (PropsFactory) getEFactoryInstance();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   private boolean isCreated = false;

   /**
    * Creates the meta-model objects for the package. This method is guarded to
    * have no affect on any invocation but its first. <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * 
    * @generated
    */
   public void createPackageContents() {
      if (isCreated)
         return;
      isCreated = true;

      // Create classes and their features
      documentRootEClass = createEClass(DOCUMENT_ROOT);
      createEAttribute(documentRootEClass, DOCUMENT_ROOT__MIXED);
      createEReference(documentRootEClass, DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
      createEReference(documentRootEClass, DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
      createEReference(documentRootEClass,
            DOCUMENT_ROOT__IMPLEMENTATION_PROPERTIES);

      propertiesImplementationEClass = createEClass(PROPERTIES_IMPLEMENTATION);
      createEAttribute(propertiesImplementationEClass,
            PROPERTIES_IMPLEMENTATION__ANY);
      createEAttribute(propertiesImplementationEClass,
            PROPERTIES_IMPLEMENTATION__PROPERTIES);
      createEAttribute(propertiesImplementationEClass,
            PROPERTIES_IMPLEMENTATION__ANY_ATTRIBUTE);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   private boolean isInitialized = false;

   /**
    * Complete the initialization of the package and its meta-model. This method
    * is guarded to have no affect on any invocation but its first. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public void initializePackageContents() {
      if (isInitialized)
         return;
      isInitialized = true;

      // Initialize package
      setName(eNAME);
      setNsPrefix(eNS_PREFIX);
      setNsURI(eNS_URI);

      // Obtain other dependent packages
      SCAPackageImpl theSCAPackage = (SCAPackageImpl) EPackage.Registry.INSTANCE
            .getEPackage(SCAPackage.eNS_URI);
      XMLTypePackageImpl theXMLTypePackage = (XMLTypePackageImpl) EPackage.Registry.INSTANCE
            .getEPackage(XMLTypePackage.eNS_URI);

      // Add supertypes to classes
      propertiesImplementationEClass.getESuperTypes().add(
            theSCAPackage.getImplementation());

      // Initialize classes and features; add operations and parameters
      initEClass(
            documentRootEClass,
            DocumentRoot.class,
            "DocumentRoot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
      initEAttribute(
            getDocumentRoot_Mixed(),
            ecorePackage.getEFeatureMapEntry(),
            "mixed", null, 0, -1, null, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
      initEReference(
            getDocumentRoot_XMLNSPrefixMap(),
            ecorePackage.getEStringToStringMapEntry(),
            null,
            "xMLNSPrefixMap", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
      initEReference(
            getDocumentRoot_XSISchemaLocation(),
            ecorePackage.getEStringToStringMapEntry(),
            null,
            "xSISchemaLocation", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
      initEReference(
            getDocumentRoot_ImplementationProperties(),
            this.getPropertiesImplementation(),
            null,
            "implementationProperties", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

      initEClass(
            propertiesImplementationEClass,
            PropertiesImplementation.class,
            "PropertiesImplementation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
      initEAttribute(
            getPropertiesImplementation_Any(),
            ecorePackage.getEFeatureMapEntry(),
            "any", null, 0, -1, PropertiesImplementation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
      initEAttribute(
            getPropertiesImplementation_Properties(),
            theXMLTypePackage.getNCName(),
            "properties", null, 1, 1, PropertiesImplementation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
      initEAttribute(
            getPropertiesImplementation_AnyAttribute(),
            ecorePackage.getEFeatureMapEntry(),
            "anyAttribute", null, 0, -1, PropertiesImplementation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

      // Create resource
      createResource(eNS_URI);

      // Create annotations
      // http:///org/eclipse/emf/ecore/util/ExtendedMetaData
      createExtendedMetaDataAnnotations();
   }

   /**
    * Initializes the annotations for
    * <b>http:///org/eclipse/emf/ecore/util/ExtendedMetaData</b>. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected void createExtendedMetaDataAnnotations() {
      String source = "http:///org/eclipse/emf/ecore/util/ExtendedMetaData"; //$NON-NLS-1$		
      addAnnotation(documentRootEClass, source, new String[] { "name", "", //$NON-NLS-1$ //$NON-NLS-2$
            "kind", "mixed" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(getDocumentRoot_Mixed(), source, new String[] {
            "kind", "elementWildcard", //$NON-NLS-1$ //$NON-NLS-2$
            "name", ":mixed" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(getDocumentRoot_XMLNSPrefixMap(), source, new String[] {
            "kind", "attribute", //$NON-NLS-1$ //$NON-NLS-2$
            "name", "xmlns:prefix" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(getDocumentRoot_XSISchemaLocation(), source, new String[] {
            "kind", "attribute", //$NON-NLS-1$ //$NON-NLS-2$
            "name", "xsi:schemaLocation" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(
            getDocumentRoot_ImplementationProperties(),
            source,
            new String[] {
                  "kind", "element", //$NON-NLS-1$ //$NON-NLS-2$
                  "name", "implementation.properties", //$NON-NLS-1$ //$NON-NLS-2$
                  "namespace", "##targetNamespace", //$NON-NLS-1$ //$NON-NLS-2$
                  "affiliation", "http://www.osoa.org/xmlns/sca/0.9#implementation" //$NON-NLS-1$ //$NON-NLS-2$
            });
      addAnnotation(propertiesImplementationEClass, source, new String[] {
            "name", "PropertiesImplementation", //$NON-NLS-1$ //$NON-NLS-2$
            "kind", "elementOnly" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(getPropertiesImplementation_Any(), source, new String[] {
            "kind", "elementWildcard", //$NON-NLS-1$ //$NON-NLS-2$
            "wildcards", "##other", //$NON-NLS-1$ //$NON-NLS-2$
            "name", ":0", //$NON-NLS-1$ //$NON-NLS-2$
            "processing", "lax" //$NON-NLS-1$ //$NON-NLS-2$
      });
      addAnnotation(getPropertiesImplementation_Properties(), source,
            new String[] { "kind", "attribute", //$NON-NLS-1$ //$NON-NLS-2$
                  "name", "properties" //$NON-NLS-1$ //$NON-NLS-2$
            });
      addAnnotation(getPropertiesImplementation_AnyAttribute(), source,
            new String[] { "kind", "attributeWildcard", //$NON-NLS-1$ //$NON-NLS-2$
                  "wildcards", "##any", //$NON-NLS-1$ //$NON-NLS-2$
                  "name", ":2", //$NON-NLS-1$ //$NON-NLS-2$
                  "processing", "lax" //$NON-NLS-1$ //$NON-NLS-2$
            });
   }

} // PropsPackageImpl
