/**
 * <copyright> </copyright>
 * 
 * $Id: PropsSwitch.java,v 1.1 2006-03-31 21:58:53 melder Exp $
 */
package org.eclipse.stp.core.tests.properties.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.stp.core.sca.Implementation;
import org.eclipse.stp.core.tests.properties.DocumentRoot;
import org.eclipse.stp.core.tests.properties.PropertiesImplementation;
import org.eclipse.stp.core.tests.properties.PropsPackage;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see org.eclipse.stp.core.tests.props.PropsPackage
 * @generated
 */
public class PropsSwitch {
   /**
    * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected static PropsPackage modelPackage;

   /**
    * Creates an instance of the switch. <!-- begin-user-doc --> <!--
    * end-user-doc -->
    * 
    * @generated
    */
   public PropsSwitch() {
      if (modelPackage == null) {
         modelPackage = PropsPackage.eINSTANCE;
      }
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns
    * a non null result; it yields that result. <!-- begin-user-doc --> <!--
    * end-user-doc -->
    * 
    * @return the first non-null result returned by a <code>caseXXX</code>
    *         call.
    * @generated
    */
   public Object doSwitch(EObject theEObject) {
      return doSwitch(theEObject.eClass(), theEObject);
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns
    * a non null result; it yields that result. <!-- begin-user-doc --> <!--
    * end-user-doc -->
    * 
    * @return the first non-null result returned by a <code>caseXXX</code>
    *         call.
    * @generated
    */
   protected Object doSwitch(EClass theEClass, EObject theEObject) {
      if (theEClass.eContainer() == modelPackage) {
         return doSwitch(theEClass.getClassifierID(), theEObject);
      } else {
         List eSuperTypes = theEClass.getESuperTypes();
         return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch(
               (EClass) eSuperTypes.get(0), theEObject);
      }
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns
    * a non null result; it yields that result. <!-- begin-user-doc --> <!--
    * end-user-doc -->
    * 
    * @return the first non-null result returned by a <code>caseXXX</code>
    *         call.
    * @generated
    */
   protected Object doSwitch(int classifierID, EObject theEObject) {
      switch (classifierID) {
         case PropsPackage.DOCUMENT_ROOT: {
            DocumentRoot documentRoot = (DocumentRoot) theEObject;
            Object result = caseDocumentRoot(documentRoot);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PropsPackage.PROPERTIES_IMPLEMENTATION: {
            PropertiesImplementation propertiesImplementation = (PropertiesImplementation) theEObject;
            Object result = casePropertiesImplementation(propertiesImplementation);
            if (result == null)
               result = caseImplementation(propertiesImplementation);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         default:
            return defaultCase(theEObject);
      }
   }

   /**
    * Returns the result of interpretting the object as an instance of '<em>Document Root</em>'.
    * <!-- begin-user-doc --> This implementation returns null; returning a
    * non-null result will terminate the switch. <!-- end-user-doc -->
    * 
    * @param object
    *           the target of the switch.
    * @return the result of interpretting the object as an instance of '<em>Document Root</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public Object caseDocumentRoot(DocumentRoot object) {
      return null;
   }

   /**
    * Returns the result of interpretting the object as an instance of '<em>Properties Implementation</em>'.
    * <!-- begin-user-doc --> This implementation returns null; returning a
    * non-null result will terminate the switch. <!-- end-user-doc -->
    * 
    * @param object
    *           the target of the switch.
    * @return the result of interpretting the object as an instance of '<em>Properties Implementation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public Object casePropertiesImplementation(PropertiesImplementation object) {
      return null;
   }

   /**
    * Returns the result of interpretting the object as an instance of '<em>Implementation</em>'.
    * <!-- begin-user-doc --> This implementation returns null; returning a
    * non-null result will terminate the switch. <!-- end-user-doc -->
    * 
    * @param object
    *           the target of the switch.
    * @return the result of interpretting the object as an instance of '<em>Implementation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public Object caseImplementation(Implementation object) {
      return null;
   }

   /**
    * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
    * <!-- begin-user-doc --> This implementation returns null; returning a
    * non-null result will terminate the switch, but this is the last case
    * anyway. <!-- end-user-doc -->
    * 
    * @param object
    *           the target of the switch.
    * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject)
    * @generated
    */
   public Object defaultCase(EObject object) {
      return null;
   }

} // PropsSwitch
